﻿* Encoding: UTF-8.
*Make Paired samples
*SPSS macros by Kirill Orlov
*kior@comtv.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_HUNMATCH*/***********************************************.
define !KO_hunmatch(prox= !charend('/') /k= !charend('/') /licmat= !charend('/') /rand= !charend('/'))
!if (!prox<>'DISSIM' !and !prox<>'SIMIL') !then
-echo '>ERROR. Не задана п/к PROX.'.
!else
-set mxloops 1000000.
-matrix.
-get c.
 !if (!prox='SIMIL') !then
- comp maxsimil= mmax(c).
- comp c= maxsimil-c+1.
 !ifend
-comp c_= c.
-comp bigval= mmax(c)+1.
 !if (!k=!null) !then
- comp k= ncol(c).
 !else
- comp k= !k.
 !ifend
-comp ok= 0.
-do if nrow(c)<ncol(c).
- print /title '>ERROR. Число строк во входящей матрице меньше числа столбцов.'.
-else if not all(c).
- print /title '>ERROR. Во входящей матрице есть неположительные значения.'.
-else if k>ncol(c).
- print /title '>ERROR. Число пар K больше числа столбцов входящей матрицы.'.
-else.
- comp ok= 1.
  !if (!licmat<>!null) !then !let !iflic= 'do if lic(i,j)' !let !endif= 'end if'
-  comp ok= 0.
-  get lic /file= !licmat.
-  do if nrow(lic)<>nrow(c) or ncol(lic)<>ncol(c).
-   print /title '>ERROR. Матрица LICMAT не того же размера что входящая матрица.'.
-  else if not all((lic=1)+(lic=0)).
-   print /title '>ERROR. Матрица LICMAT должна состоять только из чисел 0 и 1.'.
-  else if not all(csum(lic)).
-   print /title '>ERROR. В матрице LICMAT есть столбцы, содержащие только 0.'.
-  else if not all(rsum(lic)).
-   print /title '>ERROR. В матрице LICMAT есть ряды, содержащие только 0.'.
-  else.
-   comp ok= 1.
-   comp c= c+(not lic)&*(msum(c)-c).
-  end if.
  !ifend
-end if.
-do if ok.
  !if (!rand='YES') !then
-  comp rnms= t({1:nrow(c)}).
-  comp cnms= t({1:ncol(c)}).
-  comp rand= grade(uniform(nrow(c),1)).
-  comp c(rand,:)= c.
-  comp rnms= rnms(rand).
-  comp rand= grade(uniform(ncol(c),1)).
-  comp c(:,rand)= c.
-  comp cnms= cnms(rand).
  !ifend
- do if k<ncol(c).
-  comp c= {c,make(nrow(c),nrow(c)-k,0)}.
-  comp c= {c;make(nrow(c)-k,ncol(c),bigval)}.
- end if.
- do if nrow(c)>ncol(c).
-  comp c= {c,make(nrow(c),nrow(c)-ncol(c),0)}.
- end if.
- comp n= nrow(c).
- comp rzero= make(1,n,0).
- comp czero= make(n,1,0).
- comp rnums= t(1:n).
- comp cnums= 1:n.
- comp c= c-rmin(c)*make(1,n,1).
- comp m= (not c)&*(make(n,1,1)*cnums).
- loop i= 1 to n.
-  comp j= rmax(m(i,:)).
-  do if j.
-   comp m(i,:)= rzero.
-   comp m(:,j)= czero.
-   comp m(i,j)= 1.
-  end if.
- end loop.
- loop.
-  comp ucr= make(n,1,1).
-  comp ucc= not csum(m).
-  do if not any(ucc).
-   break.
-  else.
-   loop.
-    comp i= 0.
-    loop j= 1 to n.
-     do if ucc(j).
-      comp i= cmax((not c(:,j))&*ucr&*rnums).
-      do if i.
-       break.
-      end if.
-     end if.
-    end loop.
-    do if i.
-     comp m(i,j)= -2.
-     do if any(m(i,:)=1).
-      comp ucr(i)= 0.
-      comp ucc(rmax(m(i,:)&*cnums))= 1.
-     else.
-      comp m(i,j)= -3.
-      loop if any(m(:,j)=1).
-       comp i2= cmax(m(:,j)&*rnums).
-       comp m(i2,j)= 0.
-       comp j2= rmax((m(i2,:)=-2)&*cnums).
-       comp m(i2,j2)= -3.
-       comp j= j2.
-      end loop.
-      comp m= m&*(m<>-3)+(m=-3).
-      comp m= m&*(m<>-2).
-      break.
-     end if.
-    else.
-     comp nnz= csum(ucr).
-     do if nnz=n.
-      comp rind= rnums.
-     else if nnz/n>.8.
-      comp rind= make(1,nnz+1,0).
-      comp cnt= 1.
-      loop #= 1 to n.
-       comp rind(cnt)= #.
-       comp cnt= cnt+ucr(#).
-      end loop.
-      comp rind= rind(1:nnz).
-     else.
-      comp rind= make(1,nnz,0).
-      comp cnt= 0.
-      loop #= 1 to n.
-       do if ucr(#).
-        comp cnt= cnt+1.
-        comp rind(cnt)= #.
-       end if.
-      end loop.
-     end if.
-     comp nnz= rsum(ucc).
-     do if nnz=n.
-      comp cind= cnums.
-     else if nnz/n>.8.
-      comp cind= make(1,nnz+1,0).
-      comp cnt= 1.
-      loop #= 1 to n.
-       comp cind(cnt)= #.
-       comp cnt= cnt+ucc(#).
-      end loop.
-      comp cind= cind(1:nnz).
-     else.
-      comp cind= make(1,nnz,0).
-      comp cnt= 0.
-      loop #= 1 to n.
-       do if ucc(#).
-        comp cnt= cnt+1.
-        comp cind(cnt)= #.
-       end if.
-      end loop.
-     end if.
-     comp min= mmin(c(rind,cind)).
-     comp c= c+(not ucr)*make(1,n,min)-make(n,1,min)*ucc.
-    end if.
-   end loop.
-  end if.
- end loop.
- comp m= m(1:nrow(c_),1:ncol(c_)).
- comp rnums= t(1:nrow(m)).
  !if (!rand='YES') !then
-  comp m= m(rnms,cnms).
  !ifend
- comp pairs= make(k,4,0).
- comp cnt= 0.
- loop j= 1 to ncol(m).
-  comp i= cmax(m(:,j)&*rnums).
-  do if i.
-   !iflic.
-    comp cnt= cnt+1.
-    comp pairs(cnt,:)= {rnums(i),cnums(j),c_(i,j), !if (!licmat<>!null) !then lic(i,j) !else 1 !ifend}.
-   !endif.
-  end if.
- end loop.
  !if (!prox='SIMIL') !then !let !tit= 'Суммарное сходство в парах:' !let !tit2= ' (максимизировано)'
-  comp pairs(:,3)= maxsimil-pairs(:,3)+1.
  !else !let !tit= 'Суммарное различие в парах:' !let !tit2= ' (минимизировано)'
  !ifend
- comp k_= csum(pairs(:,4)).
- print k /title 'Число заказанных пар между объектами-столбцами и объектами-рядами (K):'.
- print k_ /title 'Число образованных пар:'.
- do if k_<k.
-  print /title '>WARNING. Число незапрещенных пар, которые удалось создать, меньше K.' /space= 0.
- end if.
- comp pairs= pairs(:,1:3).
- print csum(pairs(:,3)) /title= !quote(!tit).
- do if k_=k.
-  print /title !quote(!tit2) /space= 0.
- end if. 
- save pairs(:,1:3) /out= * /vari= row_obj col_obj prox.
-else.
- save 0 /out= *.
-end if.
-end matrix.
-var lab row_obj 'Номер объекта-ряда' col_obj 'Номер объекта-столбца' prox 'Близость (различие или сходство)'.
-var lev row_obj col_obj (nom) /prox (sca).
-format row_obj col_obj (f8).
!ifend
!enddefine.
